- Main Page
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# number_void Class Reference

`#include <number_impl.hpp>`

Inheritance diagram for number_void:

List of all members.

## Public Member Functions
| number_void ()
## Private Member Functions
virtual std::string | do_to_string () const
virtual void | do_save (std::ostream &stream) const
virtual bool | do_equals (number_impl const &rhs) const
virtual bool | do_less (number_impl const &rhs) const
virtual number_impl * | do_add (number_impl const &rhs)
virtual number_impl * | do_subtract (number_impl const &rhs)
virtual number_impl * | do_multiply (number_impl const &rhs)
virtual number_impl * | do_divide (number_impl const &rhs)
virtual number_impl * | do_promote (number_impl &rhs) const

## Detailed Description

Represent a number without a type. A void number cannot be converted into any other type, but any type can be converted to void.

Definition at line 77 of file number_impl.hpp.

## Constructor & Destructor Documentation

number_void::number_void | ( |  | ) | `[inline]`

Definition at line 79 of file number_impl.hpp.

    00079 : number_impl() {}

## Member Function Documentation

std::string number_void::do_to_string | ( |  | ) | const`[private, virtual]`

Implements number_impl.

Definition at line 135 of file number_impl.cpp.

    00137 {
    00138   return std::string();
    00139 }

void number_void::do_save | ( | std::ostream & | stream | ) | const`[private, virtual]`

Implements number_impl.

Definition at line 141 of file number_impl.cpp.

    00143 {
    00144   stream << "void ";
    00145 }

bool number_void::do_equals | ( | number_impl const & | rhs | ) | const`[private, virtual]`

Implements number_impl.

Definition at line 148 of file number_impl.cpp.

    00150 {
    00151   return false;
    00152 }

bool number_void::do_less | ( | number_impl const & | rhs | ) | const`[private, virtual]`

Implements number_impl.

Definition at line 155 of file number_impl.cpp.

    00157 {
    00158   return false;
    00159 }

number_impl * number_void::do_add | ( | number_impl const & | rhs | ) | `[private, virtual]`

Implements number_impl.

Definition at line 162 of file number_impl.cpp.

References number_impl::add_ref().

    00163 {
    00164   add_ref();
    00165   return this;
    00166 }

number_impl * number_void::do_subtract | ( | number_impl const & | rhs | ) | `[private, virtual]`

Implements number_impl.

Definition at line 168 of file number_impl.cpp.

References number_impl::add_ref().

    00169 {
    00170   add_ref();
    00171   return this;
    00172 }

number_impl * number_void::do_multiply | ( | number_impl const & | rhs | ) | `[private, virtual]`

Implements number_impl.

Definition at line 174 of file number_impl.cpp.

References number_impl::add_ref().

    00175 {
    00176   add_ref();
    00177   return this;
    00178 }

number_impl * number_void::do_divide | ( | number_impl const & | rhs | ) | `[private, virtual]`

Implements number_impl.

Definition at line 180 of file number_impl.cpp.

References number_impl::add_ref().

    00181 {
    00182   add_ref();
    00183   return this;
    00184 }

number_impl * number_void::do_promote | ( | number_impl & | rhs | ) | const`[private, virtual]`

Implements number_impl.

Definition at line 186 of file number_impl.cpp.

References number_impl::promote_to_void().

    00188 {
    00189   return rhs.promote_to_void();
    00190 }

The documentation for this class was generated from the following files:

- number_impl.hpp
- number_impl.cpp